package com.jeesite.common.service.system.plat.win32;

import com.jeesite.common.j2cache.autoconfigure.J2CacheAutoConfiguration;
import com.jeesite.common.service.system.plat.win32.WinDef;
import com.jeesite.common.service.system.plat.win32.WinNT;
import com.jeesite.common.shiro.realms.iIiIiiiIiiiI;
import com.jeesite.common.shiro.realms.iiIIiiiiIiiI;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.Structure;
import com.sun.jna.Structure.FieldOrder;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.win32.StdCallLibrary;
import com.sun.jna.win32.W32APIOptions;
import com.sun.jna.win32.W32APITypeMapper;

public interface Wtsapi32 extends StdCallLibrary {

   int WTS_CURRENT_SESSION = -1;
   int WTS_CONSOLE_CONNECT = 1;
   int DOMAIN_LENGTH = 17;
   int WTS_REMOTE_CONNECT = 3;
   int USERNAME_LENGTH = 20;
   Wtsapi32 INSTANCE = (Wtsapi32)Native.load(J2CacheAutoConfiguration.true("Q\u0012u\u0007v\u000f5T"), Wtsapi32.class, W32APIOptions.DEFAULT_OPTIONS);
   int WTS_SESSION_LOCK = 7;
   int WTS_CONSOLE_DISCONNECT = 2;
   int WTS_SESSION_UNLOCK = 8;
   int WTS_SESSION_LOGON = 5;
   int WTS_PROCESS_INFO_LEVEL_0 = 0;
   int WTS_SESSION_REMOTE_CONTROL = 9;
   int NOTIFY_FOR_THIS_SESSION = 0;
   int NOTIFY_FOR_ALL_SESSIONS = 1;
   WinNT.HANDLE WTS_CURRENT_SERVER_HANDLE = new WinNT.HANDLE((Pointer)null);
   int WTS_ANY_SESSION = -2;
   int WINSTATIONNAME_LENGTH = 32;
   int WTS_SESSION_LOGOFF = 6;
   int WTS_PROCESS_INFO_LEVEL_1 = 1;
   int WTS_REMOTE_DISCONNECT = 4;


   boolean WTSFreeMemoryEx(int var1, Pointer var2, int var3);

   boolean WTSEnumerateSessions(WinNT.HANDLE var1, int var2, int var3, PointerByReference var4, IntByReference var5);

   boolean WTSEnumerateProcessesEx(WinNT.HANDLE var1, IntByReference var2, int var3, PointerByReference var4, IntByReference var5);

   boolean WTSUnRegisterSessionNotification(WinDef.HWND var1);

   void WTSFreeMemory(Pointer var1);

   boolean WTSQuerySessionInformation(WinNT.HANDLE var1, int var2, int var3, PointerByReference var4, IntByReference var5);

   boolean WTSRegisterSessionNotification(WinDef.HWND var1, int var2);

   @FieldOrder({"SessionId", "ProcessId", "pProcessName", "pUserSid", "NumberOfThreads", "HandleCount", "PagefileUsage", "PeakPagefileUsage", "WorkingSetSize", "PeakWorkingSetSize", "UserTime", "KernelTime"})
   public static class WTS_PROCESS_INFO_EX extends Structure {

      public int SessionId;
      public int NumberOfThreads;
      public int WorkingSetSize;
      public int ProcessId;
      public int PagefileUsage;
      public String pProcessName;
      public int HandleCount;
      public WinNT.LARGE_INTEGER KernelTime;
      public int PeakPagefileUsage;
      public WinNT.PSID pUserSid;
      public int PeakWorkingSetSize;
      public WinNT.LARGE_INTEGER UserTime;


      public WTS_PROCESS_INFO_EX() {
         super(W32APITypeMapper.DEFAULT);
      }

      public WTS_PROCESS_INFO_EX(Pointer p) {
         Wtsapi32.WTS_PROCESS_INFO_EX var10000 = this;
         Pointer this1 = p;
         Wtsapi32.WTS_PROCESS_INFO_EX p1 = var10000;
         boolean var10005 = true;
         this1.<init>(false, 1, W32APITypeMapper.DEFAULT);
         p1.read();
      }
   }

   @FieldOrder({"State", "SessionId", "IncomingBytes", "OutgoingBytes", "IncomingFrames", "OutgoingFrames", "IncomingCompressedBytes", "OutgoingCompressedBytes", "WinStationName", "Domain", "UserName", "ConnectTime", "DisconnectTime", "LastInputTime", "LogonTime", "CurrentTime"})
   public static class WTSINFO extends Structure {

      public int SessionId;
      public WinNT.LARGE_INTEGER ConnectTime;
      public int OutgoingFrames;
      public final byte[] Domain;
      public int OutgoingBytes;
      public int OutgoingCompressedBytes;
      public int IncomingBytes;
      public final byte[] WinStationName;
      public WinNT.LARGE_INTEGER LogonTime;
      public int IncomingFrames;
      public WinNT.LARGE_INTEGER LastInputTime;
      public int State;
      public final byte[] UserName;
      private static final int CHAR_WIDTH;
      public int IncomingCompressedBytes;
      public WinNT.LARGE_INTEGER CurrentTime;
      public WinNT.LARGE_INTEGER DisconnectTime;


      public String getDomain() {
         return this.true(this.fieldOffset(iiIIiiiiIiiI.true("\u0006j/d+k")));
      }

      // $FF: synthetic method
      private String true(int a1) {
         Wtsapi32.WTSINFO var10000 = a;
         int a2 = a1;
         Wtsapi32.WTSINFO a3 = var10000;
         int var3 = CHAR_WIDTH;
         boolean var10003 = true;
         return true?a3.getPointer().getString((long)a2):a3.getPointer().getWideString((long)a2);
      }

      public String getWinStationName() {
         return this.true(this.fieldOffset(iIiIiiiIiiiI.true("c\u001cZ&@\u0014@\u001c[\u001bz\u0014Y\u0010")));
      }

      public WTSINFO(Pointer p) {
         Wtsapi32.WTSINFO var10000 = this;
         Pointer this1 = p;
         Wtsapi32.WTSINFO p1 = var10000;
         boolean var10002 = true;
         boolean var10004 = true;
         p1.<init>(this1);
         (new byte[1 * CHAR_WIDTH]).WinStationName = (byte[])true;
         (new byte[1 * CHAR_WIDTH]).Domain = (byte[])true;
         (new byte[1 * CHAR_WIDTH]).UserName = (byte[])true;
         true.read();
      }

      static {
         byte var10001;
         boolean var10002;
         if(Boolean.getBoolean(iiIIiiiiIiiI.true("rq7ld1f+l"))) {
            var10001 = 1;
            var10002 = true;
         } else {
            boolean var10000 = true;
            var10001 = 1;
            var10002 = true;
         }

         CHAR_WIDTH = var10001;
      }

      public String getUserName() {
         return this.true(this.fieldOffset(iIiIiiiIiiiI.true("a\u0006Q\u0007z\u0014Y\u0010")));
      }

      public WTSINFO() {
         boolean var10001 = true;
         boolean var10003 = true;
         boolean var10005 = true;
         super();
         (new byte[1 * CHAR_WIDTH]).WinStationName = (byte[])true;
         (new byte[1 * CHAR_WIDTH]).Domain = (byte[])true;
         (new byte[1 * CHAR_WIDTH]).UserName = (byte[])true;
      }
   }

   @FieldOrder({"AddressFamily", "Address"})
   public static class WTS_CLIENT_ADDRESS extends Structure {

      public int AddressFamily;
      public byte[] Address;


      public WTS_CLIENT_ADDRESS() {
         boolean var10001 = true;
         super();
         (new byte[1]).Address = (byte[])true;
      }

      public WTS_CLIENT_ADDRESS(Pointer p) {
         Wtsapi32.WTS_CLIENT_ADDRESS var10000 = this;
         Pointer this1 = p;
         Wtsapi32.WTS_CLIENT_ADDRESS p1 = var10000;
         p1.<init>(this1);
         (new byte[1]).Address = (byte[])true;
         true.read();
      }
   }

   @FieldOrder({"SessionId", "pWinStationName", "State"})
   public static class WTS_SESSION_INFO extends Structure {

      public int SessionId;
      public int State;
      public String pWinStationName;


      public WTS_SESSION_INFO() {
         super(W32APITypeMapper.DEFAULT);
      }

      public WTS_SESSION_INFO(Pointer p) {
         Wtsapi32.WTS_SESSION_INFO var10000 = this;
         Pointer this1 = p;
         Wtsapi32.WTS_SESSION_INFO p1 = var10000;
         boolean var10005 = true;
         this1.<init>(false, 1, W32APITypeMapper.DEFAULT);
         p1.read();
      }
   }

   public interface WTS_INFO_CLASS {

      int WTSWinStationName = 6;
      int WTSIncomingBytes = 19;
      int WTSClientInfo = 23;
      int WTSIdleTime = 17;
      int WTSUserName = 5;
      int WTSWorkingDirectory = 2;
      int WTSSessionInfo = 24;
      int WTSOEMId = 3;
      int WTSApplicationName = 1;
      int WTSDomainName = 7;
      int WTSClientBuildNumber = 9;
      int WTSValidationInfo = 27;
      int WTSLogonTime = 18;
      int WTSConfigInfo = 26;
      int WTSClientName = 10;
      int WTSSessionInfoEx = 25;
      int WTSClientDisplay = 15;
      int WTSClientProductId = 12;
      int WTSClientAddress = 14;
      int WTSSessionId = 4;
      int WTSSessionAddressV4 = 28;
      int WTSIncomingFrames = 21;
      int WTSClientHardwareId = 13;
      int WTSOutgoingBytes = 20;
      int WTSIsRemoteSession = 29;
      int WTSConnectState = 8;
      int WTSClientDirectory = 11;
      int WTSClientProtocolType = 16;
      int WTSInitialProgram = 0;
      int WTSOutgoingFrames = 22;

   }

   public interface WTS_CONNECTSTATE_CLASS {

      int WTSShadow = 3;
      int WTSConnected = 1;
      int WTSListen = 6;
      int WTSActive = 0;
      int WTSConnectQuery = 2;
      int WTSDisconnected = 4;
      int WTSInit = 9;
      int WTSIdle = 5;
      int WTSDown = 8;
      int WTSReset = 7;

   }
}
